<?php
global $oPlugin, $smarty;
$cHB_URL = 'https://www.hb-intern.de/www/hbm/api/live_rechtstexte.htm';

// Prüfen ob allow_url_fopen aktiviert ist
if (ini_get('allow_url_fopen') == false){
	 echo '<div class="alert alert-danger"><i class="fa fa-info-circle"></i> ' .
        'ACHTUNG: allow_url_fopen muss aktiviert sein damit das Plugin funktioniert.</div>';
} 

// auf Update prüfen
$cURL = "http://wiki.hennweb.de/download/jtl/hb_rechtstexte/";
$cVersion = file_get_contents($cURL."version.csv");
if ($cVersion === false ) {
	echo "Versions-Prüfung nicht möglich.";
} else {
	$nVersion = intval($cVersion);
	if ( $nVersion > $oPlugin->nVersion ) {
		echo "<div class='alert alert-danger'><i class='fa fa-info-circle'></i> " .
		"neue Version verf&uuml;gbar: ".$oPlugin->nVersion." -> ".$cVersion."<br><a href='".$cURL."jtl_haendlerbund_".$nVersion.".zip'>DOWNLOAD</a></div>";
	} else {
		echo "Version: $cVersion <b>aktuell</b>";
	}
}

if ($oPlugin->oPluginEinstellungAssoc_arr['hb_nutzen'] === 'Y' && strlen($oPlugin->oPluginEinstellungAssoc_arr['hb_token']) > 0) {
    // zurücksetzen 
	if (isset($_GET['hb_activate'])) {
        if ($_GET['hb_activate'] === 'all') {
            Shop::DB()->query("UPDATE xplugin_" . $oPlugin->cPluginID . "_tupdate SET nAktiv=1, nVersuch=0, dAktualisiert='0000-00-00 00:00:00' ", 3);
        } else {
            $kUpdate = (int)$_GET['hb_activate'];
            if ($kUpdate > 0) {
                Shop::DB()->query("UPDATE xplugin_" . $oPlugin->cPluginID . "_tupdate SET nAktiv=1, nVersuch=0, dAktualisiert='0000-00-00 00:00:00' WHERE kUpdate={$kUpdate}", 3);
            }
        }
    }
	// einzelne Updates für Texte ein/aus schalten
	if (isset($_GET['hb_onoff'])) {
	    $oSwitch = Shop::DB()->query("SELECT * FROM xplugin_" . $oPlugin->cPluginID . "_tupdate WHERE kUpdate = " . $_GET['hb_onoff'], 1);
		if ($oSwitch->nOnOff == 0){
			$OnOff = 1;
		} else {
			$OnOff = 0;
		}
		Shop::DB()->query("UPDATE xplugin_" . $oPlugin->cPluginID . "_tupdate SET nAktiv=1, nVersuch=0, dAktualisiert='0000-00-00 00:00:00', nOnOff=".$OnOff." WHERE kUpdate=". $_GET['hb_onoff'], 3);
	}
	
    $oTexte_arr      = Shop::DB()->query("SELECT * FROM xplugin_" . $oPlugin->cPluginID . "_tupdate", 2);
    foreach ($oTexte_arr as $oText) {
		
		// passende ID zuweisen
		switch ($oText->cTextType) {
		case 'AGB':
			$cId_Type = '12766C46A8A';
			break;
		case 'WRB':
			switch ($oPlugin->oPluginEinstellungAssoc_arr['hb_akt_wrb']) {
			// normale WRB
			case 'WRB1':
				$cId_Type = '12766C53647';
				break;

			// digital WRB
			case 'WRB2':
				$cId_Type = '1452C24576D';
				break;
			
			// digital Dienstleistung
			case 'WRB3':
				$cId_Type = '1463C5DBF05';
				break;
			}
			break;
		case 'IMPRESSUM':
			$cId_Type = '1293C20B491';
			break;
		case 'DATENSCHUTZ':
			$cId_Type = '12766C5E204';
			break;
		case 'BATTERIE':
			$cId_Type = '134CBB4D101';
			break;
		case 'ZAHLUNG_VERSAND':
			$cId_Type = '12766C58F26';
			break;
		}
		
		// Bug Korrektur - DE darf als Parameter nicht mit übergeben werden
		if ($oText->cSprache == 'de'){
			$cSprache = '';
		} else {
			$cSprache = $oText->cSprache;
		}
				
        $cParams             = http_build_query(array(
            'APIkey'      => '1IqJF0ap6GdDNF7HKzhFyciibdml8t4v',
            'AccessToken' => $oPlugin->oPluginEinstellungAssoc_arr['hb_token'],
            'mode'        => ($oText->cFormat === 'html') ? 'classes' : 'plain',
            'did'         => $cId_Type,
			'lang'		  => $cSprache
        ), '', '&');
        $oText->cURL         = $cHB_URL . '?' . $cParams;
        $oText->cActivateUrl = "plugin.php?kPlugin={$oPlugin->kPlugin}&hb_activate={$oText->kUpdate}&cPluginTab=Status";
		$oText->cOnOffUrl    = "plugin.php?kPlugin={$oPlugin->kPlugin}&hb_onoff={$oText->kUpdate}&cPluginTab=Status";
    }
    $smarty->assign('oTexte_arr', $oTexte_arr)
           ->assign('cUrlActivateAll', "plugin.php?kPlugin={$oPlugin->kPlugin}&hb_activate=all&cPluginTab=Status")
           ->display($oPlugin->cAdminmenuPfad . 'templates/status.tpl');
} else {
    echo '<div class="alert alert-info"><i class="fa fa-info-circle"></i> ' .
        'Bitte aktivieren Sie dieses Plugin im Reiter "Einstellungen" und tragen dort auch Ihren Token ein.</div>';
		
	/**	
	 * Datenbank aktualisieren - für alle Sprachen und jeden Text einen Datensatz anlegen
	*/
	
	// alle Sprachen des Shops auslesen
	$oSprache_arr = gibAlleSprachen();

	// alle Datensätze aus der Statusdatei löschen und anschließend neu erstellen
	Shop::DB()->query("TRUNCATE xplugin_jtl_haendlerbund_tupdate", 3);
	$i = 1;
	foreach ($oSprache_arr as $oSprache_lng) {

		$lang = convertISO2ISO639($oSprache_lng->cISO);	// z.B. ger -> de , eng -> en
		
		// Nur Sprache anlegen wenn sie beim Händlerbund vorhanden sind
		if (in_array($lang, ['de', 'en', 'pl', 'es', 'it', 'nl', 'ar'], true)) {
		
			$obj       		= new stdClass();
			$obj->kUpdate	= $i++;
			$obj->cTextType	= 'AGB';
			$obj->cFormat 	= 'txt';
			$obj->nAktiv  	= 1;
			$obj->nVersuch	= 0;
			$obj->cSprache	= $lang;
			$obj->nOnOff	= 0;
			$erg = Shop::DB()->insert('xplugin_jtl_haendlerbund_tupdate', $obj);
			
			$obj       		= new stdClass();
			$obj->kUpdate	= $i++;
			$obj->cTextType	= 'AGB';
			$obj->cFormat 	= 'html';
			$obj->nAktiv  	= 1;
			$obj->nVersuch	= 0;
			$obj->cSprache	= $lang;
			$obj->nOnOff	= 0;
			$erg = Shop::DB()->insert('xplugin_jtl_haendlerbund_tupdate', $obj);
			
			$obj       		= new stdClass();
			$obj->kUpdate	= $i++;
			$obj->cTextType	= 'WRB';
			$obj->cFormat 	= 'txt';
			$obj->nAktiv  	= 1;
			$obj->nVersuch	= 0;
			$obj->cSprache	= $lang;
			$obj->nOnOff	= 0;
			$erg = Shop::DB()->insert('xplugin_jtl_haendlerbund_tupdate', $obj);
			
			$obj       		= new stdClass();
			$obj->kUpdate	= $i++;
			$obj->cTextType	= 'WRB';
			$obj->cFormat 	= 'html';
			$obj->nAktiv  	= 1;
			$obj->nVersuch	= 0;
			$obj->cSprache	= $lang;
			$obj->nOnOff	= 0;
			$erg = Shop::DB()->insert('xplugin_jtl_haendlerbund_tupdate', $obj);

			$obj       		= new stdClass();
			$obj->kUpdate	= $i++;
			$obj->cTextType	= 'IMPRESSUM';
			$obj->cFormat 	= 'html';
			$obj->nAktiv  	= 1;
			$obj->nVersuch	= 0;
			$obj->cSprache	= $lang;
			$obj->nOnOff	= 0;
			$erg = Shop::DB()->insert('xplugin_jtl_haendlerbund_tupdate', $obj);

			$obj       		= new stdClass();
			$obj->kUpdate	= $i++;
			$obj->cTextType	= 'DATENSCHUTZ';
			$obj->cFormat 	= 'html';
			$obj->nAktiv  	= 1;
			$obj->nVersuch	= 0;
			$obj->cSprache	= $lang;
			$obj->nOnOff	= 0;
			$erg = Shop::DB()->insert('xplugin_jtl_haendlerbund_tupdate', $obj);

			$obj       		= new stdClass();
			$obj->kUpdate	= $i++;
			$obj->cTextType	= 'BATTERIE';
			$obj->cFormat 	= 'html';
			$obj->nAktiv  	= 1;
			$obj->nVersuch	= 0;
			$obj->cSprache	= $lang;
			$obj->nOnOff	= 0;
			$erg = Shop::DB()->insert('xplugin_jtl_haendlerbund_tupdate', $obj);

			$obj       		= new stdClass();
			$obj->kUpdate	= $i++;
			$obj->cTextType	= 'ZAHLUNG_VERSAND';
			$obj->cFormat 	= 'html';
			$obj->nAktiv  	= 1;
			$obj->nVersuch	= 0;
			$obj->cSprache	= $lang;
			$obj->nOnOff	= 0;
			$erg = Shop::DB()->insert('xplugin_jtl_haendlerbund_tupdate', $obj);
		}
	}

}
